//20100127 - Alain Brobecker
#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */
#define TRUE 1
#define FALSE 0

int NbPawns=8;
//int Position[8]={7,8,12,13,15,36,43,44}; // >=6 captures
//int Position[8]={0,7,18,26,30,31,42,43}; // >=4 captures
//int Position[8]={7,12,13,22,27,36,43,47}; // >=4 captures
int Position[8]={0,6,8,9,10,17,22,26}; // =15 captures
//int Position[8]={0,1,2,17,24,25,31,36}; // >=9 captures
//int Position[8]={10,12,13,26,28,30,31,36}; // >=7 captures
//int Position[8]={1,4,7,12,18,39,40,43}; // >=5 captures

int Possibilities[8],SubsetPossibilities[8];
char Board[8][8];

/* for debugging */
void PrintPossibilities() {
  int Pawn,c;
  char d;
  for(Pawn=0;Pawn<NbPawns;Pawn++) {
    printf("P%c%d: ",'a'+Position[Pawn]/6,(Position[Pawn]%6)+2);    
    d='a';
    for(c=1;c<256;c=c<<1) {
      if((Possibilities[Pawn] & c)==0) { printf("."); } else { printf("%c",d); }
      d++;
    }
    printf("  ");
    d='a';
    for(c=1;c<256;c=c<<1) {
      if((SubsetPossibilities[Pawn] & c)==0) { printf("."); } else { printf("%c",d); }
      d++;
    }
    printf("\n");
  }
  printf("\n");
}

int CountBits(int Byte) {
  int c,NbBits=0;
  for(c=1;c<=128;c=c<<1) {
    if((Byte & c)!=0) { NbBits++; }
  }
  return(NbBits);
}

void PrintBoard() {
  int x,y,Pawn,c;
  for(y=0;y<8;y++) {
    for(x=0;x<8;x++) {
      Board[x][y]='.';
    }
  }
  for(Pawn=0;Pawn<NbPawns;Pawn++) {
    x=Position[Pawn]/6;
    y=Position[Pawn]%6+1;
    if(CountBits(Possibilities[Pawn])==1) {
      c=0;
      while((Possibilities[Pawn] & (1<<c))==0) { c++; }
      Board[x][y]='a'+c;
    } else {
      Board[x][y]='O';
    }
  }
  for(y=7;y>=0;y--) {
    for(x=0;x<8;x++) {
      printf("%c",Board[x][y]);
    }
    printf("\n");
  }
}

void PrintFEN() {
  int x,y,nb;
  for(y=7;y>=0;y--) {
    nb=0;
    for(x=0;x<8;x++) {
      if(Board[x][y]=='.') {
        nb++;
      } else {
        if(nb!=0) { printf("%d",nb); }
        printf("P"); //!!!NORMALLY printf("%c",Board[x][y]);
        nb=0;
      }
    }
//!!!NORMALLY    if(nb!=0) { printf("%d",nb); }
    if(nb!=0) { if(y==0){ printf("K6k"); }else{ printf("%d",nb); } }
    if(y!=0) { printf("/"); }
  }
  printf("\n");
}

/******************************************************************************
*************************                       *******************************
*************************   HOW MANY CAPTURES   *******************************
*************************                       *******************************
******************************************************************************/
/* HowManyCaptures() needs NbPawns==8, Position[8] and Possibilities[8] as
   global variables (see below for positions' numbering from white's viewpoint).
   Possibilities[0]==5 means that pawn at Position[0] comes from a or c files
   (5==%00000101==a.c.....).
   The 6*8 board is numbered the following way for white:
     7 | 5 11 17 23 29 35 41 47
     6 | 4 10 16 22 28 34 40 46
     5 | 3  9 15 21 27 33 39 45
     4 | 2  8 14 20 26 32 38 44
     3 | 1  7 13 19 25 31 37 43
     2 | 0  6 12 18 24 30 36 42
     --+-----------------------
       | a  b  c  d  e  f  g  h
   Below is the table of possible origins for a pawn at a given square: */
int PossibleOrigins[48] = {
   1,  3,  7, 15, 31, 63,  // .......a  ......ba  .....cba  ....dcba  ...edcba  ..fedcba
   2,  7, 15, 31, 63,127,  // ......b.  .....cba  ....dcba  ...edcba  ..fedcba  .gfedcba
   4, 14, 31, 63,127,255,  // .....c..  ....dcb.  ...edcba  ..fedcba  .gfedcba  hgfedcba
   8, 28, 62,127,255,255,  // ....d...  ...edc..  ..fedcb.  .gfedcba  hgfedcba  hgfedcba
  16, 56,124,254,255,255,  // ...e....  ..fed...  .gfedc..  hgfedcb.  hgfedcba  hgfedcba 
  32,112,248,252,254,255,  // ..f.....  .gfh....  hgfed...  hgfedc..  hgfedcb.  hgfedcba
  64,224,240,248,252,254,  // .g......  hgf.....  hgfe....  hgfed...  hgfedc..  hgfedcb.
 128,192,224,240,248,252}; // h.......  hg......  hgf.....  hgfe....  hgfed...  hgfedc..

int Mask,MixedPossibilities,NotMixedPossibilities;
int t1,t2,t3,Pawn,NbCaptures;
int NoChange; /* booleans */

int HowManyCaptures() {
  // (bubble) sort the pawns by position
  for(t1=0;t1<7;t1++) {
    for(t2=7;t2>t1;t2--) {
      if(Position[t2-1]>Position[t2]) { t3=Position[t2-1]; Position[t2-1]=Position[t2]; Position[t2]=t3; }
    }
  }

  for(Pawn=0;Pawn<NbPawns;Pawn++) { Possibilities[Pawn]=PossibleOrigins[Position[Pawn]]; }
/*!!! PrintPossibilities();*/
  do{
    NoChange=TRUE;
    // Check for every N-uple of Pawns if a OR of all their possibilities
    // contains exactly N bits, in which case we must kill those possibilities
    // for the other Pawns. If it contains less than N bits then the position
    // is illegal. At the end the subsets will have empty intersection.
    for(Mask=(1<<NbPawns)-1;Mask>0;Mask--) {
      MixedPossibilities=0;
      for(Pawn=0;Pawn<NbPawns;Pawn++) {
        // Is the pawn in the N-uple?
        if(((1<<Pawn) & Mask)!=0) {
          MixedPossibilities=MixedPossibilities | Possibilities[Pawn];
        }
      }
      t1=CountBits(MixedPossibilities);
      t2=CountBits(Mask);
      if(t1<t2) {
        return(-1); // Position is illegal if N pawns have less than N possibilities
      } else if(t1==t2) {
        NotMixedPossibilities=~MixedPossibilities;
        // remove those possibilities for the pawns that were not in the N-uple
        for(Pawn=0;Pawn<NbPawns;Pawn++) {
          if(((1<<Pawn) & Mask)==0) {
            t1=Possibilities[Pawn];
            t2=t1 & NotMixedPossibilities;
            if(t1!=t2) {
              Possibilities[Pawn]=t2;
              NoChange=FALSE;
/*!!! printf("%d %d\n",Mask,CountBits(Mask));*/
/*!!! PrintPossibilities();*/
            }
          }
        }
      }
    }
  } while(NoChange==FALSE);

  // Create the subsets
  Mask=0; // to say if a Pawn has been seen or not
  SubsetPossibilities[NbPawns-1]=Possibilities[NbPawns-1];
  for(Pawn=0;Pawn<NbPawns-1;Pawn++) {
    if((Mask & (1<<Pawn))==0) {
      MixedPossibilities=Possibilities[Pawn]; // will contain all possible origins for this subset
      for(t1=Pawn+1;t1<NbPawns;t1++) {
        if((Possibilities[t1] & MixedPossibilities)!=0) {
          MixedPossibilities=MixedPossibilities | Possibilities[t1];
        }
      }
      for(t1=Pawn;t1<NbPawns;t1++) {
        if((Possibilities[t1] & MixedPossibilities)!=0) {
          Mask=Mask | (1<<t1);
          SubsetPossibilities[t1]=MixedPossibilities;
        }
      }
    }
  }
  
  // Count the nb of captures
  NbCaptures=0;
  Mask=255; // valid origins
  for(Pawn=0;Pawn<NbPawns;Pawn++) {
    t1=Position[Pawn]/6; // column of the pawn
    t2=0;
    while(((1<<t2) & Mask & SubsetPossibilities[Pawn])==0) { t2++; }
    Mask=Mask & (~(1<<t2)); //remove this possibility for other pawns
    t3=t2-t1;
    if(t3<0) { t3=-t3; }
/*!!!    printf("P%c%d comes from %c: %d capture(s)\n",'a'+t1,(Position[Pawn]%6)+2,'a'+t2,t3);*/
    NbCaptures+=t3;
  }
 
/*!!! PrintPossibilities();*/
  if(NbCaptures>15) { return(-NbCaptures); }
  return(NbCaptures);
}

unsigned long long int val(P1,P2,P3,P4,P5,P6,P7,P8) int P1,P2,P3,P4,P5,P6,P7,P8; {
  unsigned long long int v;
  v=1<<(P1-6);
  v+=1<<(P2-6);
  v+=1<<(P3-6);
  v+=1<<(P4-6);
  v+=1<<(P5-6);
  v+=1<<(P6-6);
  v+=1<<(P7-6);
  v+=1<<(P8-6);
  return(v);
//  printf("%llu\n",v);
}  


//****************************************************************************

#define ActualiseMinMaxIllegal(NbCaptures) \
  if(NbCaptures<0) { \
    NbIllegal++; \
  } else { \
    if(NbCaptures==MinNbCaptures) { NbPosWithMin++; } \
    if(NbCaptures<MinNbCaptures) { \
      MinNbCaptures=NbCaptures; \
      NbPosWithMin=1; \
      minP1=Position[0]; \
      minP2=Position[1]; \
      minP3=Position[2]; \
      minP4=Position[3]; \
      minP5=Position[4]; \
      minP6=Position[5]; \
      minP7=Position[6]; \
      minP8=Position[7]; \
      } \
    if(NbCaptures==MaxNbCaptures) { NbPosWithMax++; } \
    if(NbCaptures>MaxNbCaptures) { MaxNbCaptures=NbCaptures; NbPosWithMax=1; } \
  }

int main(argc,argv) int argc; char *argv[]; {
  setbuf(stdout, NULL); /* no buffering for output! */
  
  int P1,P2,P3,P4,P5,P6,P7,P8;
  int minP1,minP2,minP3,minP4,minP5,minP6,minP7,minP8;
  int c,x,y;
  int n1,n2,n3,n4;
  int MinNbCaptures,MaxNbCaptures,NbPosWithMin,NbPosWithMax,NbIllegal;
  int MaxOfMin;
  
  unsigned long long int Diagrams[9999];
  unsigned long long int DiagramValue,MinDiagramValue;
  int NbDiagrams;
  int DiagFound;
  

//2^32     =4294967296
//14^4*29^4=27170906896
//36^8     =2821109907456
//48^8     =28179280429056
//2^64     =18446744073709551616       
           
  NbDiagrams=0;
  MaxOfMin=0;
  for(P1=6;P1<21;P1++) { //6->20=15
    printf("P1=%d\n",P1); 
    for(P2=P1+1;P2<22;P2++) { //7->21=15
      for(P3=P2+1;P3<23;P3++) { //8->22=15
        for(P4=P3+1;P4<24;P4++) { //9->23=15
          for(P5=P4+1;P5<39;P5++) { //10->38=29
            for(P6=P5+1;P6<40;P6++) { //11->39=29
              for(P7=P6+1;P7<41;P7++) { //12->40=29
                for(P8=P7+1;P8<42;P8++) { //13->41=29
/*!!! printf("(%d,%d,%d,%d,%d,%d,%d,%d) ",P1,P2,P3,P4,P5,P6,P7,P8);*/
                  Position[0]=P1;
                  Position[1]=P2;
                  Position[2]=P3;
                  Position[3]=P4;
                  Position[4]=P5;
                  Position[5]=P6;
                  Position[6]=P7;
                  Position[7]=P8;
                  NbIllegal=0;
                  MinNbCaptures=16;
                  NbPosWithMin=0;
                  MaxNbCaptures=-1;
                  NbPosWithMax=0;
                  n1=HowManyCaptures(8,Position,Possibilities);
                  ActualiseMinMaxIllegal(n1)
                  for(c=0;c<8;c++) { x=Position[c]; y=x%6; x=(x-6)/6; Position[c]=6+y*6+(5-x); } //rot90
                  n2=HowManyCaptures(8,Position,Possibilities);
                  ActualiseMinMaxIllegal(n2)
                  for(c=0;c<8;c++) { x=Position[c]; y=x%6; x=(x-6)/6; Position[c]=6+y*6+(5-x); } //rot90
                  n3=HowManyCaptures(8,Position,Possibilities);
                  ActualiseMinMaxIllegal(n3)
                  for(c=0;c<8;c++) { x=Position[c]; y=x%6; x=(x-6)/6; Position[c]=6+y*6+(5-x); } //rot90
                  n4=HowManyCaptures(8,Position,Possibilities);
                  ActualiseMinMaxIllegal(n4)
//!!! NO POSITIONS: if((NbPosWithMin==3) && (MaxNbCaptures==MinNbCaptures+1) && (MinNbCaptures>=MaxOfMin) && (NbIllegal==0)) {
//!!! NO POSITIONS: if((NbPosWithMin==2) && (MaxNbCaptures==MinNbCaptures+1) && (MinNbCaptures>=MaxOfMin) && (NbIllegal==1)) {
//                    if(MinNbCaptures>=MaxOfMin) { MaxOfMin=MinNbCaptures; }
//!!! ????          if( (NbIllegal==0) || ((NbIllegal==1) && (NbPosWithMin==1)) ) {
//                    if((NbPosWithMin==1) && (MinNbCaptures>=MaxOfMin) && (NbIllegal==1)) {
//!!! GOOD          if((MaxNbCaptures==MinNbCaptures+1) && (MinNbCaptures==10) && (NbIllegal==0)) {
//!!! GOOD        if((NbPosWithMin==3) && (MinNbCaptures>=MaxOfMin) && (NbIllegal==0)) {
                  if((MaxNbCaptures==MinNbCaptures+1) && (MinNbCaptures>=MaxOfMin) && (NbIllegal==0)) {
  
                      MinDiagramValue=val(Position[0],Position[1],Position[2],Position[3],Position[4],Position[5],Position[6],Position[7]);
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; Position[c]=x-y+(5-y); } //hflip
                      DiagramValue=val(Position[0],Position[1],Position[2],Position[3],Position[4],Position[5],Position[6],Position[7]);
                      if(DiagramValue<MinDiagramValue) { MinDiagramValue=DiagramValue; }
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; Position[c]=x-y+(5-y); } //hflip
                      
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; x=(x-6)/6; Position[c]=6+y*6+(5-x); } //rot90
                      DiagramValue=val(Position[0],Position[1],Position[2],Position[3],Position[4],Position[5],Position[6],Position[7]);
                      if(DiagramValue<MinDiagramValue) { MinDiagramValue=DiagramValue; }
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; Position[c]=x-y+(5-y); } //hflip
                      DiagramValue=val(Position[0],Position[1],Position[2],Position[3],Position[4],Position[5],Position[6],Position[7]);
                      if(DiagramValue<MinDiagramValue) { MinDiagramValue=DiagramValue; }
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; Position[c]=x-y+(5-y); } //hflip
                      
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; x=(x-6)/6; Position[c]=6+y*6+(5-x); } //rot90
                      DiagramValue=val(Position[0],Position[1],Position[2],Position[3],Position[4],Position[5],Position[6],Position[7]);
                      if(DiagramValue<MinDiagramValue) { MinDiagramValue=DiagramValue; }
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; Position[c]=x-y+(5-y); } //hflip
                      DiagramValue=val(Position[0],Position[1],Position[2],Position[3],Position[4],Position[5],Position[6],Position[7]);
                      if(DiagramValue<MinDiagramValue) { MinDiagramValue=DiagramValue; }
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; Position[c]=x-y+(5-y); } //hflip
                      
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; x=(x-6)/6; Position[c]=6+y*6+(5-x); } //rot90
                      DiagramValue=val(Position[0],Position[1],Position[2],Position[3],Position[4],Position[5],Position[6],Position[7]);
                      if(DiagramValue<MinDiagramValue) { MinDiagramValue=DiagramValue; }
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; Position[c]=x-y+(5-y); } //hflip
                      DiagramValue=val(Position[0],Position[1],Position[2],Position[3],Position[4],Position[5],Position[6],Position[7]);
                      if(DiagramValue<MinDiagramValue) { MinDiagramValue=DiagramValue; }
                      for(c=0;c<8;c++) { x=Position[c]; y=x%6; Position[c]=x-y+(5-y); } //hflip
                                            
                      DiagFound=FALSE;
                      c=0;
                      while((c<NbDiagrams) && (DiagFound==FALSE)) {
                        if(Diagrams[c]==MinDiagramValue) {
                          DiagFound=TRUE;
                        }
                        c++;
                      }
                      if(DiagFound==FALSE) {
                        MaxOfMin=MinNbCaptures;
                        Diagrams[NbDiagrams]=MinDiagramValue;
//!!!                        printf("%d:%llu\n",NbDiagrams,Diagrams[NbDiagrams]);
                        NbDiagrams++;
                        Position[0]=minP1;
                        Position[1]=minP2;
                        Position[2]=minP3;
                        Position[3]=minP4;
                        Position[4]=minP5;
                        Position[5]=minP6;
                        Position[6]=minP7;
                        Position[7]=minP8;
                        n1=HowManyCaptures(8,Position,Possibilities);
                        PrintBoard();
                        printf("illegalx%d min=%dx%d max=%dx%d\n",NbIllegal,MinNbCaptures,NbPosWithMin,MaxNbCaptures,NbPosWithMax);
                        
                      }
//!!!               }
                  }
                } // next P8
              }
            }
          }
        }
      }
    }
  }
  exit(0);
}
